      $SET COMP NOQUAL NOALTER NOOSVS VSC2 ANS85
      *************************************************************************
       DATA DIVISION.
      *
       WORKING-STORAGE SECTION.
      *
       01  Concurrent-Variables.
           03  C-25                        PIC X COMP-X VALUE 25.
           03  CCB-Command-Line.
               05  CCB-Command-Line-Count  PIC X COMP-X.
               05  CCB-Command-Line-Text   PIC X(128).
           03  Control-Flag                PIC X COMP-X VALUE 0.
               78  Request-Command         VALUE 0.
               78  Command-Received        VALUE 1.
               78  Request-To-Send         VALUE 2.
               78  Clear-To-Send           VALUE 3.
           03  Co-Stat                     PIC X COMP-X VALUE 68.
           03  Message-Value-Pointer       USAGE IS POINTER.
           03  Message-Name.
               05  Message-Name-Size       PIC X COMP-X VALUE 19.
               05  Message-Name-Value      PIC X(19)
                                       VALUE "COMMUNICATIONS-AREA".
           03  Parent-Thread-ID.
               05  Parent-ID               PIC XXXX COMP-5.
           03  Temp                        PIC X COMP-X.
           03  Thread-ID                   PIC XXXX COMP-5.
           03  Thread-Status               PIC XX COMP-X.
      *
       LINKAGE SECTION.
      *
       01  Concurrent-Control.
           03  CC-Access-Flag              PIC X COMP-X.
           03  CC-Area-Status              PIC X COMP-X.
               78  CC-Area-Free            VALUE 0.
               78  CC-Command              VALUE 1.
               78  CC-Status               VALUE 2.
               78  CC-Data                 VALUE 3.
           03  CC-Identifier-To            PIC XXXX COMP-5.
           03  CC-Identifier-From          PIC XXXX COMP-5.
           03  CC-Control-Info             PIC X COMP-X.
      * Commands
               78  CC-Terminate-Thread     VALUE 1.
      * Status
               78  CC-Thread-Terminated    VALUE 1.
      *
           03  CC-Data-Area                PIC X(255).
      *
      *************************************************************************
      *
       PROCEDURE DIVISION.
      *
       ConDemo SECTION.
      *
      *  Read the communications buffer to get parents Thread Id.
      *
           MOVE 80 TO CCB-Command-Line-Count.
           CALL X"91" USING Temp, C-25, CCB-Command-Line.
           MOVE CCB-Command-Line-Text (3:4) TO Parent-Thread-ID.
      *
      *  Read the command line information passed from parent
      *
           ACCEPT CCB-Command-Line-Text FROM COMMAND-LINE.
      *
           CALL "_TGETVAL" USING Message-Value-Pointer,
                                 Message-Name.
           IF Return-Code NOT = 0
               DISPLAY "Thread communication area is not available"
               STOP RUN.
      *
           SET ADDRESS OF Concurrent-Control TO Message-Value-Pointer.
      *
      *  Get own thread id and status information.
      *
           MOVE 0 TO Thread-ID.
           CALL X"91" USING Thread-ID, Co-Stat, Thread-Status.
      *
           CALL CCB-Command-Line-Text
               ON EXCEPTION
                   CONTINUE
           END-CALL.
      *
           PERFORM Wait-For-Control-Area.
           MOVE CC-Thread-Terminated TO CC-Control-Info.
           PERFORM Set-Status-Transfer.
           STOP RUN.
      *
      *************************************************************************
      *
       Check-Interface SECTION.
      *
      *  The CC-Access-Flag is used as a semaphore byte, 1 is added to
      *  its value and if it is still 1 no one else is accessing the
      *  communications area at this time.
      *  The "ADD 1 TO byte" being an atomic operation
      *  (non interruptable)
      *
           ADD 1 TO CC-Access-Flag.
           IF CC-Access-Flag = 1 AND
              CC-Area-Status NOT = CC-Area-Free AND
              CC-Identifier-To = Thread-Id
               IF CC-Area-Status = CC-Command
                   EVALUATE CC-Control-Info
                   WHEN CC-Terminate-Thread
                       MOVE CC-Thread-Terminated TO CC-Control-Info
                       PERFORM Set-Status-Transfer
                       STOP RUN
                   WHEN OTHER
                       MOVE CC-Area-Free TO CC-Area-Status
                   END-EVALUATE
               ELSE
                   MOVE CC-Area-Free TO CC-Area-Status.
           IF CC-Access-Flag = 1 AND
              CC-Area-Status = CC-Area-Free
               IF Control-Flag = Request-To-Send
                   MOVE Clear-To-Send TO Control-Flag
               ELSE
                   SUBTRACT 1 FROM CC-Access-Flag
           ELSE
               SUBTRACT 1 FROM CC-Access-Flag.
      *
      *************************************************************************
      *
       Release-Time-Slice SECTION.
           CALL "_COYIELD".
      *
      *************************************************************************
      *
       Set-Status-Transfer SECTION.
           MOVE Thread-ID TO CC-Identifier-From.
           MOVE Parent-ID TO CC-Identifier-To.
           MOVE CC-Status TO CC-Area-Status.
           SUBTRACT 1 FROM CC-Access-Flag.
      *
      *************************************************************************
      *
       Wait-For-Control-Area SECTION.
       Wait-Control.
           MOVE Request-To-Send TO Control-Flag.
           PERFORM Check-Interface.
           IF Control-Flag NOT = Clear-To-Send
               PERFORM Release-Time-Slice
               GO TO Wait-Control.
      *
      *************************************************************************
