      ************************************************************
      * 							 *
      * 	     (C) Micro Focus Ltd. 1989			 *
      * 							 *
      * 		    EXTFHWR.CBL 			 *
      * 							 *
      *    This program demonstrates how to use C to interface	 *
      *    to the external file handler.  The COBOL program	 *
      *    creates the ISAM test file for EXTFHRD C program.	 *
      *    To execute the example C program type EXTFHWR.  The	 *
      *    program will read and display 3 data records in ftest *
      *    on the screen with status codes returned from the	 *
      *    EXTFH calls. 					 *
      * 							 *
      *    Other files are:					 *
      * 							 *
      *      EXTFHRD.C	- c program which calls the external file*
      * 		  handler to read and display data from  *
      * 		  a file created by EXTFHWR.CBL.	 *
      *      MAKEFIL	- command file for input to make utility *
      * 		  to compile and link EXTFHRD.C program. *
      *      EXTFHWR.CBL					 *
      * 							 *
      * 							 *
      ************************************************************

       identification division.
       program-id. extfhwr.
       environment division.
       configuration section.
       source-computer.  pc.
       object-computer.  pc.
       input-output section.
       file-control.
	   select   ix-fd2 assign
	   "FTEST"
	      organization is indexed
	      access  sequential
	      file status is ix-fd2-status
	      record  ix-fd2-key.
       data division.
       file section.
       fd  ix-fd2
	   label records are standard
	   block contains 49
	   record contains  49	characters
	   data records ix-fd2r1-f-g-49.
       01  ix-fd2r1-f-g-49.
	   05 ix-fd2-key       pic x(29).
	   05 ix-fd2-rec-20    pic x(20).
       working-storage section.
       01  ix-fd2-status     pic  xx  value  space.
       procedure division.
       open-file.
	   open     output    ix-fd2.
	   move 1 to ix-fd2-key.
	   move all "A" to ix-fd2-rec-20.
	   write   ix-fd2r1-f-g-49.
	   move 2 to ix-fd2-key.
	   move all "B" to ix-fd2-rec-20.
	   write   ix-fd2r1-f-g-49.
	   move 3 to ix-fd2-key.
	   move all "C" to ix-fd2-rec-20.
	   write   ix-fd2r1-f-g-49.
	   close    ix-fd2.
	   stop run.
