      *  SCCS Source : Extracted on 88/06/30 at 10:58:39
      $set ans85

      * set compiler switches as this uses ANSI '85 syntax

      ******************************************************************
      *                                                                *
      *     MICRO FOCUS                       This software is the     *
      *     2465 E Bayshore Road              Copyright of Micro Focus *
      *     Palo Alto                         Ltd, 1986.  Permission to*
      *     California                        copy and use this program*
      *     USA 94303                         is granted without charge*
      *                                       so long as use is for    *
      *     415-856-4161                      incorporation into the   *
      *                                       Micro Focus COBOL/2      *
      *                                       Workbench software.      *
      *                                                                *
      ******************************************************************

      ******************************************************************
      *  Micro Focus Integrated Preprocessor                           *
      *                                                                *
      *  Introduction.                                                 *
      *                                                                *
      *   The Micro Focus Checker incorporates an interface which      *
      *  allows users to integrate their own preprocessor into the     *
      *  Check phase. The preprocessor may be single or multipass      *
      *  and may itself invoke other preprocessors                     *
      *                                                                *
      *  The preprocessor is integrated with the checker as:           *
      *                                                                *
      *    1) The preprocess phase can become virtually invisible      *
      *       to the user: even listing files contain only the         *
      *       original source                                          *
      *                                                                *
      *    2) It allows the user to Animate the original source. Thus  *
      *       making the power of Animated debugging available  to     *
      *       a wide range of special syntax extensions not supported  *
      *       directly by Micro Focus                                  *
      *                                                                *
      *    3) The preprocessor(s) becomes integrated into the          *
      *       Workbench Checker allowing useful features such as       *
      *       return to editor on preprocess error                     *
      *                                                                *
      *                                                                *
      *  How it works                                                  *
      *                                                                *
      *    The preprocessor interface works on the simple concept      *
      *   that preprocessing is merely a form of editing.              *
      *                                                                *
      *    The preprocessor simply has to indicate those lines which   *
      *   are deleted, inserted and which have remained unchanged      *
      *   whilst the checker receives the the original source lines    *
      *   intermingled with those that have been edited.               *
      *                                                                *
      *     COPY files can be handled either by the preprocessor or    *
      *   left to the Checker to process as usual (n.b. exceptions     *
      *   below)                                                       *
      *                                                                *
      *                                                                *
      *  Debugging your preprocessor                                   *
      *                                                                *
      *     As the preprocessor becomes an integrated part of the      *
      *   Checker, Animator can be used to animate the Workbench       *
      *   Checker and thereby the calls to the preprocessor.           *
      *                                                                *
      *                                                                *
      *  Example preprocessor                                          *
      *                                                                *
      *    The preprocessor provided is a simple example of the        *
      *    functionality made available by the interface. It uses a    *
      *    special source file ASMCOBOL.CBL and a copy file            *
      *    WORKING.CBL as input.                                       *
      *                                                                *
      ******************************************************************

      /*****************************************************************
      *                                                                *
      * The program (PREPROC.CBL) is an example COBOL integrated       *
      * preprocessor for use with Micro Focus Cobol/2 Workbench System *
      *                                                                *
      *                                                                *
      *  The example preprocessor demonstrates how:                    *
      *                                                                *
      *    1) The preprocessor is invoked and opens source input       *
      *    2) Source is passed without editing to the compiler         *
      *    3) Source is edited and then passed to the compiler         *
      *    4) A COPY statement on a single line is handled             *
      *    5) A warning message is passed from the preprocessor        *
      *    6) The preprocessor exits to the editor on error            *
      *    7) The compiler will handle COPY statements                 *
      *    8) Preprocessors can be stacked                             *
      *                                                                *
      *                                                                *
      * The example preprocessor edits the input source as follows:    *
      *                                                                *
      *    1) Any lexical token MOV is made into MOVE                  *
      *                                                                *
      *    2) Any lexical token DIS causes a new line to be inserted   *
      *       as follows:                                              *
      *                     DISPLAY SPACE UPON CRT                     *
      *       and the token DIS to be replaced by DISPLAY              *
      *                                                                *
      *    3) Any lexical token CPY is treated by the preprocessor as  *
      *       a COPY statement                                         *
      *                                                                *
      *    4) Any lexical token PRINT is made into DISPLAY             *
      *                                                                *
      *                                                                *
      * The preprocessor includes an example of a lexical analyzer for *
      * Cobol, which will handle lexical tokens which do not continue  *
      * across records.                                                *
      *                                                                *
      ******************************************************************

      /*****************************************************************
      *                                                                *
      * The following is currently defined for the preprocessor:       *
      *                                                                *
      * 1. A checker directive which tells the checker to invoke the   *
      *    preprocessor and which preprocessor to use.  The format of  *
      *    the directive is:                                           *
      *                                                                *
      *                PREPROCESS (preprocessor-name)                  *
      *                                                                *
      * 2. An initial call to the preprocessor by the checker, at the  *
      *    point when it would normally open the Cobol source file to  *
      *    be checked, whose name for example purposes is              *
      *    "asmcobol.cbl"                                              *
      *    and where the checker command line has a "command-tail" of  *
      *    directives for the preprocessor.                            *
      *    The form of the call is:                                    *
      *                                                                *
      *                CALL PREP-NAM USING C-0 FILE-NAME               *
      *                                                                *
      *    where: C-0      =   PIC 99    COMP-X  VALUE 0               *
      *           FILENAME =   PIC X(80)         VALUE "asmcobol.cbl"  *
      *    and                                                         *
      *           the command line contains directives for the         *
      *           preprocessor terminated by the character H"7F"       *
      *                                                                *
      *    which returns C-0 non-zero if there are errors encountered. *
      *                                                                *
      * 3. Successive calls to the preprocessor by the checker, at the *
      *    point when the checker would normally read the Cobol source.*
      *    The preprocessor places the Cobol source in the             *
      *    record-buffer having read it and/or edited it from the      *
      *    original Cobol source file or Copy file.                    *
      *                                                                *
      *    The form of the call is:                                    *
      *                                                                *
      *                CALL PREP-NAM USING C-1 RECORD-BUFFER           *
      *                                                                *
      *    where: C-1           =   PIC 99    COMP-X  VALUE 1          *
      *           RECORD-BUFFER =   PIC X(80)                          *
      *                                                                *
      ******************************************************************


      /*****************************************************************
      *                                                                *
      *   The sequence columns 5 and 6 in the record buffer are used   *
      *   to pass information about the record contents. The columns   *
      *   are used as PIC 99 COMP-X fields, as follows:                *
      *                                                                *
      *   COL-6  = 0  end of input                                     *
      *            1  new line added by preprocessor                   *
      *            2  old line commented out by preprocessor           *
      *            3  old line commented out containing start          *
      *                 of a COPY statement                            *
      *            4  COPY statement continued into this record        *
      *            5  warning message inserted by the preprocessor     *
      *            6  error in preprocessing so enter editor           *
      *           32  line not touched by the preprocessor             *
      *          128  end of Copy file - record must be blank          *
      *                                                                *
      *                                                                *
      *   COL-5    (Only used when COL-6 = 1 or 3)                     *
      *                                                                *
      *  When COL-6 = 1                                                *
      *       COL-5 = 0 No cobol verb replacement                      *
      *             = nn index location of cobol verb in commented text*
      *                                                                *
      *  When COL-6 = 3                                                *
      *       COL-5 = nn index to start of word "COPY".                *
      *                                                                *
      *                                                                *
      * The original source line should be passed first, followed by   *
      * the edited line.                                               *
      *                                                                *
      * COPY support handled by checker                                *
      *       Simple COPY                                              *
      *       Simple COPY spread over several lines                    *
      *       COPY Name-1 OF/IN Libname                                *
      *       Nested COPY's                                            *
      *       ++INCLUDE                                                *
      *       Also the Preprocessor may choose to preprocess selected  *
      *       COPY files itself                                        *
      *                                                                *
      *  Not supported                                                 *
      *       COPY REPLACING                                           *
      *                                                                *
      * Other syntax not supported by the checker                      *
      * (i.e. the preprocessor is expected to handle):-                *
      *   REPLACE (ANS85 verb)                                         *
      *   BASIS mechanism                                              *
      *                                                                *
      ******************************************************************


      /*****************************************************************
      *                                                                *
      * The preprocessor can be invoked from the command line as       *
      * follows:                                                       *
      *                                                                *
      *      WB CHECK asmcobol PREPROCESS (preproc)       - DOS        *
      *     PWB CHECK asmcobol PREPROCESS (preproc)       - OS/2       *
      *                                                                *
      * Where                                                          *
      *    "asmcobol.cbl"                                              *
      *       is the name of the original Cobol source code to be      *
      *       preprocessed                                             *
      *    "preproc" is the name of the preprocessor                   *
      *                                                                *
      * or whilst running Workbench in integrated mode (with function  *
      * keys etc - not from the command line), by using the F3 Check   *
      * function  &  F10  ("Options"),  checking  the  source  file    *
      * "asmcobol" as usual, but keying in the additional directive:   *
      *                                                                *
      *      PREPROCESS (preproc)                                      *
      *                                                                *
      * The preprocess directive may alternatively be placed in the    *
      * COBOL.DIR (or other directives file) or be included in a $SET  *
      * statement on first line of the program to be preprocessed      *
      * (as is the case with example asmcobol), however it should not  *
      * be specified in more than place.                               *
      *                                                                *
      *                                                                *
      * To check the example program with the preprocessor PREPROC.    *
      *                                                                *
      *    Firstly                                                     *
      *      Check the preprocessor program. (PREPROC)                 *
      *                                                                *
      *    Then                                                        *
      *      From Workbench use F3 Check as above.                     *
      *                                                                *
      ******************************************************************


      ******************************************************************
      *                                                                *
      * The preprocessor can be Animated, assuming it has been checked *
      * as usual, and the file stem names are as before:               *
      *                                                                *
      * From within Workbench                                          *
      *   Select F4 Animate and type the program name CHECK            *
      *                              (To Animate the checker)          *
      *                                                                *
      *    Use F9/F10 (Options) to enter the Checker command line      *
      *      "END asmcobol anim list etc ...."                         *
      *                                                                *
      * For source programs where a $SET statement is not included     *
      * to invoke the preprocessor the command-line would be:          *
      *      "END asmcobol anim list preprocess(Preproc) ..."          *
      *                                                                *
      ******************************************************************

      /*****************************************************************
      *                                                                *
      *  Multiple (Stacked) Preprocessors.                             *
      *                                                                *
      *  A mechanism is provided which allows several preprocessors    *
      *  to be simulataneously active on the same source program.      *
      *  This is achieved by allowing the preprocess directive to be   *
      *  stacked on the command line (or $SET etc) in the order in     *
      *  which they are to be called from the checker.                 *
      *                                                                *
      *  The command line is of the format:                            *
      *                                                                *
      * WB CHECK asmcobol PREPROCESS(preproc) [PREPROCESS(proprox)]... *
      *                                                                *
      *  where preproc - invoked from the Checker                      *
      *    and preprox - invoked from preproc                          *
      *                                                                *
      ******************************************************************

      ******************************************************************
      *                                                                *
      *  Writing A Stackable Preprocessor                              *
      *                                                                *
      *  A stackable preprocessor is identical to one which is not     *
      *  stackable except that it should contain extra code to invoke  *
      *  another preprocessor if this is necessary.                    *
      *                                                                *
      *  As the Checker is invoking the first preprocessor it writes   *
      *  to the command line the 'tail' of the PREPROCESS directive    *
      *  (eg another PREPROCESS directive or preprocessor directives)  *
      *  The stackable preprocessor should, when it is called, read    *
      *  this command line and if present invoke the preprocessor      *
      *  named in any PREPROCESS directive, passing the 'tail' of this *
      *  directive by writing it to the command line.                  *
      *                                                                *
      *  The interface between two preprocessors is identical to that  *
      *  between the Checker and preprocessor specified above, such    *
      *  that it is possible to use a stackable preprocessor in both   *
      *  stacked and unstacked situations.                             *
      *                                                                *
      *  It should also be noted that a preprocessor which has not     *
      *  been designed to be stackable may be stacked last thus        *
      *  forming the very front end to the Checker.                    *
      *                                                                *
      ******************************************************************

      ******************************************************************
      *                                                                *
      *  Language Levels                                               *
      *                                                                *
      *  The preprocessors in a stack represent langauge levels so     *
      *  that a source line may be edited several times by the         *
      *  different preprocessors on it's route through the stack       *
      *  to the Checker, but when the source line reaches the          *
      *  Checker it must be valid COBOL syntax.                        *
      *                                                                *
      *  The order in which the stacking takes place should thus be    *
      *  chosen carefully if code altered by one preprocessor is also  *
      *  to be successfully modified by a second.                      *
      *                                                                *
      ******************************************************************

      ******************************************************************
      *                                                                *
      *  Limitations                                                   *
      *                                                                *
      *  The DIRECTIVES file processing is currently limited to        *
      *  processing only the first record of the file.                 *
      *                                                                *
      ******************************************************************

      /*****************************************************************
      *                                                                *
      *  Beginning of the example Integrated Pre-Processor             *
      *                                                                *
      ******************************************************************

       identification division.
           program-id.    integrated-preprocessor.
           author.        Micro Focus.
           installation.  Micro Focus COBOL/2 Workbench.
           date-written.  8 August 1986.
           date-compiled. 8 August 1986.
           security.      Copyright protection.

       environment division.
           configuration section.
           source-computer. ibm-pc.
           object-computer. ibm-pc.

       special-names.
           command-line is cmd-line.

       select main-file assign main-file-name
            organization line sequential
            status is file-stat.

       select copy-file assign copy-file-name
           organization line sequential
           status is file-stat.

       select trace-file assign "trace.cbl"
            organization line sequential
            status is file-stat.

       select console-file assign "con:"
           organization line sequential
           status is file-stat.

       select dir-file assign dir-file-name
           organization line sequential
           status is file-stat.

       file section.

       fd main-file.
       01  main-rec.
          02 filler pic x(80).

       fd copy-file.
       01  copy-rec.
          02 filler pic x(80).

       fd trace-file.
       01  trace-rec.
          02 filler pic x(80).

       fd console-file.
       01  console-rec.
          02 filler pic x(80).

       fd dir-file.
       01  dir-rec.
          02 filler pic x(80).
      /
       working-storage section.

       01  file-stat.
           02 stat-1           pic 9.
           02 stat-2           pic 9.

       77  unfinished-action   pic 9(2)    comp-x.
       77  copy-file-active    pic 9(2)    comp-x.
       77  input-empty         pic 9(2)    comp-x.
       77  output-ready        pic 9(2)    comp-x.
       77  input-to-return     pic 9(2)    comp-x.
       77  edit-active         pic 9(2)    comp-x.
       77  edit-to-return      pic 9(2)    comp-x.
       77  overflow-active     pic 9(2)    comp-x.
       77  prep-active         pic 9(2)    comp-x.

       77  token               pic 9(2)    comp-x.
       77  token-delimit       pic 9(2)    comp-x.
       77  char                pic 9(2)    comp-x.
       77  pp                  pic 9(2)    comp-x.
       77  temp                pic 9(2)    comp-x.
       77  temp-2              pic 9(2)    comp-x.
       77  temp-X              pic X.
       77  error-message-text  pic x(40)   value
                                     "Pre-Processor Syntax in error".

       01  input-buffer.
           02  input-byte          pic 9(2)    comp-x      occurs 80.
           02  input-layout redefines input-byte.
               03   filler         pic x(4).
               03   in-col-5       pic 9(2)    comp-x.
               03   in-col-6       pic 9(2)    comp-x.
               03   in-col-7       pic 9(2)    comp-x.
               03   filler         pic x(65).
               03   in-col-73      pic 9(2)    comp-x.
               03   filler         pic x(7).
       77  input-count             pic 9(2)    comp-x.

       01  output-buffer.
           02  output-byte         pic 9(2)    comp-x      occurs 80.
           02  output-layout redefines output-byte.
               03   filler         pic x(4).
               03   out-col-5      pic 9(2)    comp-x.
               03   out-col-6      pic 9(2)    comp-x.
               03   out-col-7-80   pic x(74).
       77  output-count            pic 9(2)    comp-x.

       01  overflow-buffer.
           02  overflow-byte       pic 9(2)    comp-x      occurs 80.
           02  overflow-layout redefines overflow-byte.
               03   filler         pic x(4).
               03   over-col-5     pic 9(2)    comp-x.
               03   over-col-6     pic 9(2)    comp-x.
               03   filler         pic x(74).
       77  overflow-count          pic 9(2)    comp-x.

       01  cmdline                 pic x(80).

       01  next-prep               pic x(8).

       01  lex-buffer.
           02  lex-byte            pic 9(2)    comp-x      occurs 80.
           02  lex-layout redefines lex-byte.
               03  lex-1-30        pic X(30).
               03  filler          pic X(50).
       77  lex-count               pic 9(2)    comp-x.
      /
       78  do-copy                                value  1.
       78  do-error                               value  2.

       78  val-A                                  value  H"41".
       78  val-Z                                  value  H"5A".
       78  val-a-lc                               value  H"61".
       78  val-z-lc                               value  H"7A".
       78  val-lc-to-UC                           value  H"20".
       78  val-zero                               value  H"30".
       78  val-nine                               value  H"39".
       78  val-space                              value  H"20".
       78  val-file-slash                         VALUE  H"5C".

       78  val-eor                                value  H"FF".
       78  val-eoc                                value  H"FE".
       78  val-eof                                value  H"FD".
       78  val-eol                                value  H"7F".
       78  val-period                             value  H"2E".
       78  val-plus                               value  H"2B".
       78  val-minus                              value  H"2D".
       78  val-quote                              value  H"22".
       78  val-apostrophe                         value  H"27".
       78  val-mult                               value  H"2A".
       78  val-asterisk                           value  H"2A".
       78  val-div                                value  H"2F".
       78  val-slash                              value  H"2F".
       78  val-lbkt                               value  H"28".
       78  val-rbkt                               value  H"29".
       78  val-equal                              value  H"3D".
       78  val-gt                                 value  H"3E".
       78  val-lt                                 value  H"3C".
       78  val-semi                               value  H"3B".
       78  val-comma                              value  H"2C".

       78  tok-word                               value  1.
       78  tok-numb                               value  2.
       78  tok-eor                                value  3.
       78  tok-eoc                                value  4.
       78  tok-eof                                value  5.
       78  tok-period                             value  6.
       78  tok-plus                               value  7.
       78  tok-minus                              value  8.
       78  tok-an-lit                             value  9.
       78  tok-mult                               value  10.
       78  tok-div                                value  11.
       78  tok-lbkt                               value  12.
       78  tok-rbkt                               value  13.
       78  tok-equal                              value  14.
       78  tok-gt                                 value  15.
       78  tok-lt                                 value  16.
       78  tok-ge                                 value  17.
       78  tok-le                                 value  18.
       78  tok-error                              value  19.

       78  val-false                              value  0.
       78  val-true                               value  1.

       78  sound-beep                             value X"E5".
       78  keybd-read                             value X"83".

      /*****************************************************************
      *                                                                *
      * when trace-flag = val-true then TRACE.CBL is created as a trace*
      * file, to contain a copy of buffer for every return from the    *
      * pre-processor to the compiler ... a useful debugging aide.     *
      *                                                                *
      ******************************************************************


       77  trace-flag              pic 9(2)    comp-x  value val-false.

       linkage section.

       01  mode-flag               pic 9(2)    comp-x.
       01  buffer                  pic x(80).


      /*****************************************************************
      *                                                                *
      * Procedure Division.                                            *
      *                                                                *
      ******************************************************************

       procedure division using mode-flag, buffer.

       start-para section.
           if mode-flag = 0
               move val-false to prep-active
               accept input-buffer from cmd-line
               if input-buffer not = spaces
                   perform analyse-command-line
               else
                   perform open-main-file
               end-if
               move val-true  to input-empty
               move val-false to copy-file-active
               move val-false to output-ready
               move val-false to input-to-return
               move val-false to edit-active
               move val-false to edit-to-return
               move val-false to overflow-active
               move 7 to output-count
               move 12 to overflow-count
               move 0 to unfinished-action
           else
               perform preprocess until output-ready = val-true
               if input-to-return = val-true
                   move input-buffer to buffer
                   move val-true to input-empty
                   move val-false to input-to-return
                   move edit-to-return to output-ready
               else
                   if edit-to-return = val-true
                       move output-buffer to buffer
                       move spaces to output-buffer
                       move 7 to output-count
                       move overflow-active to output-ready
                       move overflow-active to edit-to-return
                       if overflow-active = val-true
                           move overflow-buffer to output-buffer
                           move overflow-count  to output-count
                           move spaces to overflow-buffer
                           move 12 to overflow-count
                           move val-false to overflow-active
                       end-if
                   end-if
               end-if
           perform trace-record
           end-if.
       start-x.
           exit program.


      /*****************************************************************
      *                                                                *
      * open, close and main and copy source code files                *
      *                                                                *
      ******************************************************************

       open-main-file section.
           open output console-file.
           move buffer to main-file-name.
           open input main-file.
           if stat-1 not = 0
              move 255 to mode-flag
           else
               if trace-flag = val-true
                   open output trace-file
                   if stat-1 not = 0
                       move 255 to mode-flag
                   end-if
               end-if
           end-if.

       close-main-file section.
           close main-file console-file
           if trace-flag = val-true
               close trace-file
           end-if
           move 0 to in-col-6
           move val-true to output-ready.

       trace-record section.
           if trace-flag = val-true
               move buffer to trace-rec
               write trace-rec
           end-if.

      /*****************************************************************
      *                                                                *
      *    routine to process copy verb                                *
      *    if the copy file is on two lines then set flag & get        *
      *    name of the copy file next time through.                    *
      *    otherwise get the name of copy file and open it.            *
      *                                                                *
      ******************************************************************

       open-copy-file section.
           move 3 to in-col-6
           move input-count to in-col-5
           subtract 5 from in-col-5
           perform read-token
           evaluate token
               when tok-word
               when tok-an-lit
                   move lex-1-30 to copy-file-name
                   open input copy-file
                   if stat-1 not = 0
                       move 255 to mode-flag
                   else
                       move val-true to copy-file-active
                   end-if
               when tok-eor
                   move do-copy to unfinished-action
               when other
                   move 255 to mode-flag
           end-evaluate
           move val-true to output-ready.

       continue-copy-file section.
           perform open-copy-file
           move 0 to in-col-5
           move 4 to in-col-6.

       close-copy-file section.
           close copy-file
           move val-false to copy-file-active
           move spaces to input-buffer
           move 128 to in-col-6
           move val-true to output-ready.

      /*****************************************************************
      *                                                                *
      * read main and copy source code files                           *
      *                                                                *
      ******************************************************************

       read-record section.
           if copy-file-active = val-false
               if prep-active = val-true
                   move spaces to input-buffer
                   call next-prep using mode-flag input-buffer
               else
                   read main-file
                       at end
                           move spaces to input-buffer
                           move val-eof to in-col-73
                       not at end
                           move main-rec to input-buffer
                           move val-eor to in-col-73
               end-if
           else
               read copy-file
                   at end
                       move spaces to input-buffer
                       move val-eoc to in-col-73
                   not at end
                       move copy-rec to input-buffer
                       move val-eor to in-col-73
           end-if
            evaluate in-col-6
               when 0 move spaces to input-buffer
                      move val-eof to in-col-73
                      move val-space to char
      *for the moment we'll not change modified lines
               when 1 move val-eor to char
               when 2 move val-eor to char
               when 3 move val-eor to char
               when 4 move val-eor to char
               when 5 move val-eor to char
               when 6 move val-eor to char
               when 128 move val-eor to char
               when other
                   if in-col-7 = val-asterisk or in-col-7 = val-slash
                       move val-eor to char
                   else
                       move val-space to char
                   end-if
           end-evaluate
           move 8 to input-count
           if prep-active = val-false
               move val-space to in-col-6
           end-if
           move val-false to input-empty.
           move val-true to input-to-return.

      ******************************************************************
      *                                                                *
      *  RDCH        read a character from the input record            *
      *                                                                *
      ******************************************************************

       rdch section.
           move input-byte (input-count) to char.
           add 1 to input-count.

       ppch section.
           move input-byte (input-count) to pp.

       lexch section.
           move char to lex-byte (lex-count).
           add 1 to lex-count.


      /*****************************************************************
      *                                                                *
      *  EDIT-SETUP      prepare to output an edited record            *
      *                                                                *
      ******************************************************************

       edit-setup section.
           if edit-active = val-false
               move input-count to temp
               subtract lex-count from temp
               perform until output-count = temp
                   move input-byte (output-count) to
                                              output-byte (output-count)
                   add 1 to output-count
               end-perform
               move val-true to edit-active
           end-if.


       move-token section.
           move lex-count to temp
           add output-count to temp
           if token = tok-an-lit
              subtract 1 from lex-count
              if input-count not =  74
                  add 1 to temp
              end-if
           end-if.
           if temp > 72
               move val-true to overflow-active
               move 0         to over-col-5
               move out-col-6 to over-col-6
           end-if
           move 1 to temp
           perform move-delimit
           if overflow-active = val-false
               perform until temp > lex-count
                   move lex-byte (temp) to output-byte (output-count)
                   add 1 to temp
                   add 1 to output-count
               end-perform
           else
               perform until temp > lex-count
                   move lex-byte(temp) to overflow-byte (overflow-count)
                   add 1 to temp
                   add 1 to overflow-count
               end-perform
           end-if
           perform move-delimit.

       move-delimit section.
           if token = tok-an-lit
               if overflow-active = val-false
                   move token-delimit to output-byte (output-count)
                   add 1 to output-count
               else
                   move token-delimit to overflow-byte (overflow-count)
                   add 1 to overflow-count
               end-if
           end-if.

      /*****************************************************************
      *                                                                *
      *  READ-TOKEN  -  main lexical analysis subroutine               *
      *                                                                *
      *                 input : char     = next character from input   *
      *                                                                *
      *                 result: token    = lexical token type          *
      *                         LEX-1-30 = lexical symbol string       *
      *                                                                *
      ******************************************************************

       read-token section.
           move 1 to lex-count.
           move spaces to lex-1-30.
       rt-loop.
           perform rdch
               until char not = val-space.
           evaluate char
               when val-A thru val-Z
                   perform rt-word
               when val-a-lc thru val-z-lc
                   subtract val-lc-to-uc from char
                   perform rt-word
               when val-zero thru val-nine
                   perform rt-numb
               when val-eor
                   move tok-eor to token
               when val-period
                   move tok-period to token
                   perform rt-numb-query
               when val-plus
                   move tok-plus to token
                   perform rt-numb-query
               when val-minus
                   move tok-minus to token
                   perform rt-numb-query
               when val-quote
               when val-apostrophe
                   perform rt-lit
               when val-mult
                   move tok-mult to token
                   perform rdch
               when val-div
                   move tok-div  to token
                   perform rdch
               when val-lbkt
                   move tok-lbkt to token
                   perform rdch
               when val-rbkt
                   move tok-rbkt to token
                   perform rdch
               when val-equal
                   move tok-equal to token
                   perform rdch
               when val-gt
                   move tok-gt to token
                   perform rt-compare
               when val-lt
                   move tok-lt to token
                   perform rt-compare
               when val-semi
               when val-comma
                   perform rdch
                   go to rt-loop
               when val-eoc
                   move tok-eoc to token
               when val-eof
                   move tok-eof to token
               when val-file-slash
                   perform rt-word
               when val-eol
                   continue
               when other
                   move tok-error to token
                   display "Preprocessor error: unrecognised token"
           end-evaluate.
      *
      /*****************************************************************
      *                                                                *
      *  RT-WORD       read a word.  leaves CHAR = next character      *
      *                                                                *
      ******************************************************************

       rt-word section.
           move tok-word to token.
       rt-word-l.
           perform lexch.
           perform rdch.
           evaluate char
               when val-A thru val-Z
               when val-zero thru val-nine
               when val-minus
               WHEN val-file-slash
                   go to rt-word-l
               when val-a-lc thru val-z-lc
                   subtract val-lc-to-uc from char
                   go to rt-word-l
           end-evaluate.


      ******************************************************************
      *                                                                *
      *  RT-NUMB       read a number. leaves CHAR = next character     *
      *                                                                *
      ******************************************************************

       rt-numb section.
           move tok-numb to token.
       rt-numb-l.
           perform lexch.
           perform rdch.
           evaluate char
               when val-zero thru val-nine
                   go to rt-numb-l
               when val-period
                   perform ppch
                   if pp >= val-zero and pp <= val-nine
                       go to rt-numb-l
                   end-if
           end-evaluate.

       rt-numb-query section.
           perform lexch.
           perform rdch.
           evaluate char
               when val-zero thru val-nine
               perform rt-numb
           end-evaluate.

      /*****************************************************************
      *                                                                *
      *  RT-LIT        read alphanumeric literal. leaves CHAR = next ch*
      *                eliminates lead & trail quote/apostrophe        *
      *                                                                *
      ******************************************************************

       rt-lit section.
           move char to token-delimit.
           move tok-an-lit to token.
       rt-lit-l.
           perform rdch
           evaluate char
               when val-quote
               when val-apostrophe
                   if char = token-delimit
                       perform rdch
                   else
                       perform lexch
                       go to rt-lit-l
                   end-if
               when val-eor
                   move val-eor to char
               when other
                   perform lexch
                   go to rt-lit-l
           end-evaluate.


      ******************************************************************
      *                                                                *
      *  RT-COMPARE    read a comparator symbol ( <= >= ). leaves CHAR=*
      *                                                                *
      ******************************************************************

       rt-compare section.
           perform lexch.
           perform rdch.
           if char = val-equal
               if token = tok-gt then move tok-ge to token
                                 else move tok-le to token
               end-if
               perform lexch
               perform rdch
           end-if.
       rt-compare-x.
           exit.


      /*****************************************************************
      *                                                                *
      * PREPROCESS      the main program                               *
      *                                                                *
      ******************************************************************

       preprocess section.
           if input-empty = val-true
               perform read-record
           end-if
           if unfinished-action not = 0
               perform tidy-up
           else
               perform read-token
               evaluate token
                   when tok-word
                       evaluate lex-1-30
                           when "PRINT"
                               perform print-routine
                           when "CPY"
                               perform open-copy-file
                           when other
                               if edit-active = val-true
                                   perform move-token
                               end-if
                       end-evaluate
                   when tok-eor
                       if edit-active = val-true
                           move val-true to edit-to-return
                           move val-false to edit-active
                       end-if
                       move val-true to output-ready
                   when tok-eof
                       perform close-main-file
                   when tok-eoc
                       perform close-copy-file
                   when tok-error
                       move 255 to mode-flag
                       move val-true to output-ready
                   when other
                       if edit-active = val-true
                           perform move-token
                       end-if
               end-evaluate
           end-if.


      /*****************************************************************
      *                                                                *
      * routines to tidy-up the various pre-processor tasks            *
      *                                                                *
      ******************************************************************

       tidy-up section.
           move unfinished-action to temp
           move 0 to unfinished-action
           evaluate temp
               when do-copy
                   perform continue-copy-file
               when do-error
                   perform continue-error-routine
               when other
                   display "TIDY-UP: ENTRY - BUT NOT ACTIVE !"
                   move 255 to mode-flag
           end-evaluate.


      /*****************************************************************
      *                                                                *
      *    routine to process PRINT verb                               *
      *                                                                *
      ******************************************************************


       print-routine section.
           perform edit-setup
           move "DISPLAY " to lex-1-30
           move 8 to lex-count
           move 2 to  in-col-6
           move 1 to out-col-6
           move output-count to out-col-5
           perform move-token.



      ******************************************************************
      *                                                                *
      * this routine will insert a warning into the list file.         *
      * the warning must have the format of a comment line.            *
      *                                                                *
      ******************************************************************

        warn-routine section.
           move 0 to out-col-5
           move 5 to out-col-6
           move "* EXAMPLE WARNING MESSAGE" to out-col-7-80
           move val-true to edit-to-return.




      /*****************************************************************
      *                                                                *
      * This routine can signal the compiler to switch into the editor.*
      * at the point in the source code where the pre-processor finds  *
      * an error.                                                      *
      * Note: all open source files are closed before switching to the *
      * editor.  Also, note that a record is passed back to the compiler
      * to flush out a buffered listing record in the compiler, BEFORE *
      * entering the interactive Y/N sequence.  The flush record ..... *
      * "* ... warning ... etc" appears on the user screen AFTER the   *
      * interactive sequence, if the user choses to continue, as the   *
      * compiler treats the warning message as another buffered record.*
      *                                                                *
      ******************************************************************

        error-routine section.
           move 0 to out-col-5
           move 5 to out-col-6
           move "*  WARNING .... PRE-PROCESSOR ERROR" to out-col-7-80
           move val-true to output-ready
           move val-false to input-to-return
           move val-true to edit-to-return
           move val-false to overflow-active
           move spaces to overflow-buffer
           move 12 to overflow-count
           move do-error to unfinished-action.


        continue-error-routine section.
           perform varying temp from 1 by 1 until temp = input-count
               move val-asterisk to overflow-byte ( temp )
           end-perform
           write console-rec from input-buffer
           write console-rec from overflow-buffer
           write console-rec from error-message-text
           write console-rec from "CONTINUE CHECKING PROGRAM ?   Yes/No"
           call sound-beep
           call keybd-read using temp-X
           if temp-X = 'N' or temp-X = 'n'
               display error-message-text upon cmd-line
               move spaces to input-buffer
               move 9 to in-col-5
               move 6 to in-col-6
               move val-true to output-ready
               move val-true to input-to-return
               move val-false to edit-to-return
               close main-file
               close copy-file
           else
               move val-true to input-to-return
               move spaces to overflow-buffer
           end-if.

      /*****************************************************************
       analyse-command-line section.
           move 1 to input-count.
       analyse-again.
           perform read-token
               evaluate lex-1-30
                   when "PREPROCESS"
                     move val-true to prep-active
      *write to command line
                     perform read-token
                     perform read-token
                     move input-count to temp
                     add 1 to temp
                     subtract temp from 80 giving temp-2
                     move input-buffer(temp:temp-2) to cmdline
                     display cmdline upon cmd-line
      *call next preprocessor
                     move lex-1-30(1:8) to next-prep
                     call next-prep using mode-flag buffer
                 when "DIRECTIVES"
                     perform read-directives
                     move 1 to input-count
                     perform read-token
                     go to analyse-again
                 when spaces
                     perform open-main-file
                 when other
                   move tok-error to token
                   display "PREPROC ERROR: UNRECOGNISED PARAMETER"
                 end-evaluate.


      /*****************************************************************
       read-directives section.
           perform read-token
           move input-count to temp-2
           perform read-token
           move lex-1-30 to dir-file-name
           subtract temp-2 from input-count giving temp
           add 1 to temp
           perform read-token
           move lex-1-30 to dir-file-name(temp:1)
           add 1 to temp
           perform read-token
           move lex-1-30 to dir-file-name(temp:3)

               open input dir-file
               if stat-1 not = 0
                   move tok-error to token
                   display "PREPROC ERROR: INVALID DIRECTIVES FILE"
               else
                   read dir-file
      *only allowing a one line file at present
                   move dir-rec to input-buffer
                   close dir-file.

      ******************************************************************
      *                                                                *
      * End of example Integrated Pre-Processor                        *
      *                                                                *
      ******************************************************************
