	;****************************************************************
	;*								*
	;*  XPANDDOS.ASM : pc-dos version of XPAND.CBL's asm module	*
	;*		   implements FindFirst and FindNext file names	*
	;*		   for a file specification			*
	;*								*
	;****************************************************************

	public	FindFirst
	public	FindNext

	assume	cs:cseg

cseg	segment	byte public 'CODE'

FindFirst	proc	far

	push	bp
	mov	bp,sp
					; first make file spec an asciiz string
	les	di,[bp+6]		; es:di points to file spec
	mov	al,' '			; search for space
	mov	cx,128			; must find it so make cx too large
  repnz	scasb
	dec	di
	xor	al,al			; replace by zero
	stosb

	lds	dx,[bp+6]		; reload the file spec into ds:dx
	xor	cx,cx			; return all normal files
	mov	ah,4eh			; find the first one
	int	21h			; call DOS to do this
	jc	FF_noname		; no name found -->

	mov	ah,2fh			; info has gone to DTA so get curr.
	int	21h			; DTA address
	mov	ax,es
	mov	ds,ax
	mov	si,bx			; ds:si points to info returned
	add	si,30			; ds:si = file name
	les	di,[bp+10]		; es:di = place to store file name
	mov	cx,128			; cx = length of file name area

FF_copyname:
	lodsb				; first char of file name
	or	al,al			; zero terminates file name
	jz	FF_spacefill		; end of file name -->
	stosb				; store the character
	loop	FF_copyname		; next character
	jmp	short FF_spacefill

FF_noname:
	les	di,[bp+10]		; no name found so zero out file
	mov	cx,128			; name field
					; ... fall through into ...
FF_spacefill:
	mov	al,' '			; space fill the rest of the field
   rep	stosb

	mov	sp,bp
	pop	bp
	ret

FindFirst	endp


FindNext	proc	far

	push	bp
	mov	bp,sp

	mov	ah,4fh			; find the next file from previous 
	int	21h			; spec given in FindFirst
	jc	FN_noname   		; no name found -->

	mov	ah,2fh			; info has gone to DTA so get curr.
	int	21h			; DTA address
	mov	ax,es
	mov	ds,ax
	mov	si,bx			; ds:si points to info returned
	add	si,30			; ds:si = file name
	les	di,[bp+6]		; es:di = place to store file name
	mov	cx,128			; cx = length of file name area

FN_copyname:
	lodsb				; first char of file name
	or	al,al			; zero terminates file name
	jz	FN_spacefill		; end of file name -->
	stosb				; store the character
	loop	FN_copyname		; next character
	jmp	short FN_spacefill

FN_noname:
	les	di,[bp+6]		; no name found so zero out file
	mov	cx,128			; name field
					; ... fall through into ...
FN_spacefill:
	mov	al,' '			; space fill the rest of the field
   rep	stosb

	mov	sp,bp
	pop	bp
	ret

FindNext	endp

cseg	ends
	end
