	;****************************************************************
	;*								*
	;*  XPANDOS2.ASM : OS/2 version of XPAND.CBL's asm module	*
	;*		   implements FindFirst and FindNext file names	*
	;*		   for a file specification			*
	;*								*
	;****************************************************************

	public	FindFirst
	public	FindNext

	extrn	DOSFINDFIRST:far
	extrn	DOSFINDNEXT:far

	assume	cs:cseg,es:dseg

dseg	segment	byte public 'DATA'

resbuf		db	36 dup (?)		; result buffer
one		dw	1			; constant one
dirhandle	dw	1			; directory handle

dseg	ends

cseg	segment	byte public 'CODE'

.286c

FindFirst	proc	far

	push	bp
	mov	bp,sp
					; first make file spec an asciiz string
	les	di,[bp+6]		; es:di points to file spec
	mov	al,' '			; search for space
	mov	cx,128			; must find it so make cx too large
  repnz	scasb
	dec	di
	xor	al,al			; replace by zero
	stosb

	push	word ptr [bp+8]		; push address of file spec
	push	word ptr [bp+6]
	push	seg dseg		
	push	offset dseg:dirhandle	; push addr of std. directory handle
	push	0			; search attribute = all normal files
	push	seg dseg		; push address of result buffer
	push	offset dseg:resbuf
	push	36			; push result buffer length
	push	seg dseg		; get me one entry only
	push	offset dseg:one
	push	0			; dword reserved
	push	0	
	call	DOSFINDFIRST		; call DOS to do this
	or	ax,ax			; name found ?
	jnz	FF_noname		; no -->

	mov	ax,seg dseg
	mov	ds,ax
	mov	si,offset dseg:resbuf+23; ds:si points to file name returned
	les	di,[bp+10]		; es:di = place to store file name
	mov	cx,128			; cx = length of file name area

FF_copyname:
	lodsb				; first char of file name
	or	al,al			; zero terminates file name
	jz	FF_spacefill		; end of file name -->
	stosb				; store the character
	loop	FF_copyname		; next character
	jmp	short FF_spacefill

FF_noname:
	les	di,[bp+10]		; no name found so zero out file
	mov	cx,128			; name field		       
					; ... fall through into ...
FF_spacefill:
	mov	al,' '			; space fill the rest of the field
   rep	stosb

	mov	sp,bp
	pop	bp
	ret

FindFirst	endp


FindNext	proc	far

	push	bp
	mov	bp,sp

	push	1			; push standard directory handle
	push	seg dseg		; push address of result buffer
	push	offset dseg:resbuf
	push	36			; push result buffer length
	push	seg dseg		; get me one entry only
	push	offset dseg:one
	call	DOSFINDNEXT 		; call DOS to do this
	or	ax,ax			; name found ?
	jnz	FN_noname		; no -->

	mov	ax,seg dseg
	mov	ds,ax
	mov	si,offset dseg:resbuf+23; ds:si points to file name returned
	les	di,[bp+6]		; es:di = place to store file name
	mov	cx,128			; cx = length of file name area

FN_copyname:
	lodsb				; first char of file name
	or	al,al			; zero terminates file name
	jz	FN_spacefill		; end of file name -->
	stosb				; store the character
	loop	FN_copyname		; next character
	jmp	short FN_spacefill

FN_noname:
	les	di,[bp+6]		; no name found so zero out file
	mov	cx,128			; name field
					; ... fall through into ...
FN_spacefill:
	mov	al,' '			; space fill the rest of the field
   rep	stosb

	mov	sp,bp
	pop	bp
	ret

FindNext	endp

cseg	ends
	end
